<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "partner_site_review_response".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PartnerSiteReviewResponse".
 *
 * Columns in table "partner_site_review_response" available as properties of the model,
 * followed by relations of table "partner_site_review_response" available as properties of the model.
 *
 * @property integer $id
 * @property integer $partner_site_id
 * @property string $partner_site_review_id
 * @property string $internal_review_id
 * @property string $review_response
 * @property string $review_response_date_added
 * @property string $status
 * @property string $external_username
 * @property string $external_password
 * @property string $json_details
 * @property string $date_added
 * @property string $date_updated
 *
 * @property PartnerSite $partnerSite
 * @property PartnerSiteReviewResponseLog[] $partnerSiteReviewResponseLogs
 */
abstract class BasePartnerSiteReviewResponse extends BaseModel
{

    public static function model($className = __class__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'partner_site_review_response';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PartnerSiteReviewResponse|PartnerSiteReviewResponses', $n);
    }

    public static function representingColumn()
    {
        return 'review_response_date_added';
    }

    public function rules()
    {
        return array(
            array(
                'partner_site_id, review_response_date_added, external_username, date_added, date_updated',
                'required'
            ),
            array('partner_site_id', 'numerical', 'integerOnly' => true),
            array('partner_site_review_id, internal_review_id, external_username, external_password', 'length', 'max' => 50),
            array('status', 'length', 'max' => 1),
            array('review_response, json_details', 'safe'),
            array(
                'partner_site_review_id, internal_review_id, review_response, status, external_password, json_details',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, partner_site_id, partner_site_review_id, internal_review_id, review_response, review_response_date_added, status,
                    external_username, external_password, json_details, date_added, date_updated',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'partnerSite' => array(self::BELONGS_TO, 'PartnerSite', 'partner_site_id'),
            'partnerSiteReviewResponseLogs' => array(
                self::HAS_MANY,
                'PartnerSiteReviewResponseLog',
                'partner_site_review_response_id'
            ),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'partner_site_id' => null,
            'partner_site_review_id' => Yii::t('app', 'Partner Site Review'),
            'review_response' => Yii::t('app', 'Review Response'),
            'review_response_date_added' => Yii::t('app', 'Review Response Date Added'),
            'status' => Yii::t('app', 'Status'),
            'external_username' => Yii::t('app', 'External Username'),
            'external_password' => Yii::t('app', 'External Password'),
            'json_details' => Yii::t('app', 'Json Details'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'partnerSite' => null,
            'partnerSiteReviewResponseLogs' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('partner_site_id', $this->partner_site_id);
        $criteria->compare('partner_site_review_id', $this->partner_site_review_id, true);
        $criteria->compare('internal_review_id', $this->internal_review_id, true);
        $criteria->compare('review_response', $this->review_response, true);
        $criteria->compare('review_response_date_added', $this->review_response_date_added, true);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('external_username', $this->external_username, true);
        $criteria->compare('external_password', $this->external_password, true);
        $criteria->compare('json_details', $this->json_details, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
